Attribute VB_Name = "FillArea"
Option Explicit
DefLng A-Z


Function FloodFill(FillPic As PictureBox, ByVal X As Single, ByVal Y As Single, ByVal SpotColour As Long, ByVal FillColour As Long, Optional ByVal Stack As Long = 10000, Optional ByVal FillPattern As FillStyleConstants)

    Dim Px() As Long
    Dim Py() As Long
    Dim Pstart As Long
    Dim Pstop As Long
    Dim Pcount As Long
    Dim Colour As Long
    
    Dim Lx As Long
    Dim Ly As Long
    
    Dim Sloop As Long

    Dim Ftop As Long
    Dim Fleft As Long
    Dim Fbot As Long
    Dim Fright As Long
    Dim OurGrey As Long
    Dim Ecount As Long
    Dim FillWith As Long
    Dim InFill As Long
    Dim Void As Long
    Dim OurLine As Long

    Dim GoodSpot As Long
    Dim SetPoint As Long
    Dim WorkVal As Double
    Dim FirstPoint As Long

    Const Gap = 10

    On Error GoTo FloodFillErr

    FillWith = FillColour
    If FillPattern = vbFSSolid Then
    Else
        OurGrey = RGB(192, 192, 192)
        OurLine = FillWith
        FillWith = OurGrey
        With FillPic
            Ftop = .ScaleHeight
            Fleft = .ScaleWidth
            Fbot = 0
            Fright = 0
        End With
        FirstPoint = True
    End If

    ReDim Px(0)
    ReDim Py(0)

    Lx = X
    Ly = Y

    Pstart = 0
    Pstop = 0
    Px(0) = Lx
    Py(0) = Ly
    GoSub AddPoints
    While Pstart < Pstop
        Lx = Px(Pstart)
        Ly = Py(Pstart)
        Colour = FillPic.Point(Lx, Ly)
        If Colour = SpotColour Then
            If Colour = FillWith Then
            Else
                Pcount = Pcount + 1
                FillPic.PSet (Lx, Ly), FillWith
                If FirstPoint Then
                    FillWith = FillPic.Point(Lx, Ly)
                    FirstPoint = False
                End If
                    ' Support Restricted Pallet
                If FillPattern = vbFSSolid Then
                Else
                    If Lx < Fleft Then
                        Fleft = Lx
                    End If
                    If Lx > Fright Then
                        Fright = Lx
                    End If
                    If Ly < Ftop Then
                        Ftop = Ly
                    End If
                    If Ly > Fbot Then
                        Fbot = Ly
                    End If
                End If
                GoSub AddPoints
            End If
        End If
        Pstart = Pstart + 1
    Wend

    ReDim Px(0)
    ReDim Py(0)

    If FillPattern = vbFSSolid Then
        ' We Are Done
    Else
        ' We Know The Bounding Rectangle
        ' Need To Draw The Pattern
        Select Case FillPattern
            Case vbCross
                GoSub DoCross
            Case vbDiagonalCross
                GoSub DiagonalCross
            Case vbDownwardDiagonal
                SetPoint = True
                GoSub DownDiagonal
            Case vbHorizontalLine
                SetPoint = True
                GoSub Hline
            Case vbUpwardDiagonal
                SetPoint = True
                GoSub UpDiagonal
            Case vbVerticalLine
                SetPoint = True
                GoSub Vline
        End Select
    End If

    If Ecount Then
        Pcount = 0
    End If
    
    FloodFill = Pcount

    GoTo FloodFillEnd
    
Vline:

    For Lx = Fleft To Fright
        For Ly = Ftop To Fbot
            Colour = FillPic.Point(Lx, Ly)
            If Colour = OurGrey Then
                If Lx Mod Gap Then
                    If SetPoint Then
                        FillPic.PSet (Lx, Ly), SpotColour
                    End If
                Else
                    FillPic.PSet (Lx, Ly), OurLine
                End If
            End If
        Next Ly
    Next Lx

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

UpDiagonal:

    WorkVal = ((Fbot - Ftop) * (Fbot - Ftop)) + ((Fright - Fleft) * (Fright - Fleft))
    WorkVal = Sqr(WorkVal)
    WorkVal = WorkVal / Gap
    WorkVal = Fix(WorkVal)
    If WorkVal < 20 Then
        WorkVal = 20
    End If
    For Ly = Ftop To Fbot
        For Lx = Fleft To Fright
            Colour = FillPic.Point(Lx, Ly)
            If Colour = OurGrey Then
                GoodSpot = False
                For Sloop = 0 To WorkVal
                    If Fright - Lx = Ly - Ftop - (Sloop * Gap) Then
                        GoodSpot = True
                    End If
                    If Fright - Lx = Ly - Ftop + (Sloop * Gap) Then
                        GoodSpot = True
                    End If
                Next Sloop
                If GoodSpot Then
                    FillPic.PSet (Lx, Ly), OurLine
                Else
                    If SetPoint Then
                        FillPic.PSet (Lx, Ly), SpotColour
                    End If
                End If
            End If
        Next Lx
    Next Ly

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    
Hline:

    For Ly = Ftop To Fbot
        For Lx = Fleft To Fright
            Colour = FillPic.Point(Lx, Ly)
            If Colour = OurGrey Then
                If Ly Mod Gap Then
                    If SetPoint Then
                        FillPic.PSet (Lx, Ly), SpotColour
                    End If
                Else
                    FillPic.PSet (Lx, Ly), OurLine
                End If
            End If
        Next Lx
    Next Ly

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
DownDiagonal:

    WorkVal = ((Fbot - Ftop) * (Fbot - Ftop)) + ((Fright - Fleft) * (Fright - Fleft))
    WorkVal = Sqr(WorkVal)
    WorkVal = WorkVal / Gap
    WorkVal = Fix(WorkVal)
    If WorkVal < 20 Then
        WorkVal = 20
    End If
    For Ly = Ftop To Fbot
        For Lx = Fleft To Fright
            Colour = FillPic.Point(Lx, Ly)
            If Colour = OurGrey Then
                GoodSpot = False
                For Sloop = 0 To WorkVal
                    If Lx = Ly + (Sloop * Gap) Then
                        GoodSpot = True
                        Exit For
                    End If
                    If Lx = Ly - (Sloop * Gap) Then
                        GoodSpot = True
                        Exit For
                    End If
                Next Sloop
                If GoodSpot Then
                    FillPic.PSet (Lx, Ly), OurLine
                Else
                    If SetPoint Then
                        FillPic.PSet (Lx, Ly), SpotColour
                    End If
                End If
            End If
        Next Lx
    Next Ly
    
    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
DiagonalCross:

    SetPoint = False
    GoSub DownDiagonal
    SetPoint = True
    GoSub UpDiagonal

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
DoCross:

    SetPoint = False
    GoSub Vline
    SetPoint = True
    GoSub Hline

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
AddPoints:

    If Pstart > Stack Then
        For Sloop = Pstart To Pstop
            Px(Sloop - Stack) = Px(Sloop)
            Py(Sloop - Stack) = Py(Sloop)
        Next Sloop
        ReDim Preserve Px(Pstop - Stack)
        ReDim Preserve Py(Pstop - Stack)
        Pstart = Pstart - Stack
        Pstop = Pstop - Stack
    End If

    ReDim Preserve Px(Pstop + 4)
    ReDim Preserve Py(Pstop + 4)

    Pstop = Pstop + 1
    Px(Pstop) = Lx + 1
    Py(Pstop) = Ly
    Pstop = Pstop + 1
    Px(Pstop) = Lx
    Py(Pstop) = Ly + 1
    Pstop = Pstop + 1
    Px(Pstop) = Lx - 1
    Py(Pstop) = Ly
    Pstop = Pstop + 1
    Px(Pstop) = Lx
    Py(Pstop) = Ly - 1

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
FloodFillErr:
    
    Ecount = Ecount + 1
    Resume Next

FloodFillEnd:

End Function


